/*
 * Copyright (C) 2003-2008 eXo Platform SAS.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Affero General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see<http://www.gnu.org/licenses/>.
 */
package org.exoplatform.services.jcr.impl.util;

import java.util.List;

/**
 * Created by The eXo Platform SAS.
 * 
 * @author <a href="mailto:Sergey.Kabashnyuk@gmail.com">Sergey Kabashnyuk</a>
 * @version $Id: $
 */
public class ArraysComparator<T> {
  /**
   * Class logger.
   */

  public void findDifferences(T[] firstArray,
                              T[] secondArray,
                              List<T> secondArrayItems,
                              List<T> sameItems,
                              List<T> firstArrayItems) {
    // same and new
    for (int i = 0; i < secondArray.length; i++) {
      boolean isSame = false;
      boolean isNew = true;
      for (int j = 0; j < firstArray.length && !isSame; j++) {
        if (firstArray[j].equals(secondArray[i])) {
          sameItems.add(secondArray[i]);
          isNew = false;
          isSame = true;
        }
      }
      if (isNew) {
        secondArrayItems.add(secondArray[i]);
      }
    }
    // removed
    for (int i = 0; i < firstArray.length; i++) {
      boolean isRemoved = true;
      for (int j = 0; j < secondArray.length && isRemoved; j++) {
        if (firstArray[j].equals(secondArray[i])) {
          isRemoved = false;
        }
      }
      if (isRemoved)
        firstArrayItems.add(firstArray[i]);
    }
  };

}
